/****************************************************************************
 * This file is part of the project AqDatabase.
 * AqDatabase (c) by 2019 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQDB_DB_P_H
#define AQDB_DB_P_H


#include "aqdb_db_be.h"

#include <aqdatabase/backendsupport/aqdb_cache.h>



struct AQDB_DB {
  GWEN_INHERIT_ELEMENT(AQDB_DB)
  GWEN_LIST_ELEMENT(AQDB_DB)
  GWEN_URL *url;

  AQDB_DB_OPEN_FN openFn;
  AQDB_DB_CREATE_FN createFn;
  AQDB_DB_CLOSE_FN closeFn;

  AQDB_DB_CHECK_FN checkFn;

  AQDB_DB_READOBJECT_FN readObjectFn;
  AQDB_DB_WRITEOBJECT_FN writeObjectFn;

  AQDB_DB_DELETEOBJECT_FN deleteObjectFn;
  AQDB_DB_ADDOBJECT_FN addObjectFn;

  AQDB_DB_OPENTABLE_FN openTableFn;
  AQDB_DB_CREATETABLE_FN createTableFn;
  AQDB_DB_CLOSETABLE_FN closeTableFn;
  AQDB_DB_GETTABLENAMELIST_FN getTableNameListFn;

  AQDB_DB_BEGINEDIT_FN beginEditFn;
  AQDB_DB_ENDEDIT_FN endEditFn;

  AQDB_DB_QUERYSUBMIT_FN querySubmitFn;
  AQDB_DB_QUERYGETFIRST_FN queryGetFirstFn;
  AQDB_DB_QUERYGETNEXT_FN queryGetNextFn;
  AQDB_DB_QUERYCLOSE_FN queryCloseFn;

  AQDB_DB_GETROLLBACKSESSIONS_FN getRollbackSessionsFn;
  AQDB_DB_UNDOSESSION_FN undoSessionFn;

  AQDB_DB_GETCOLUMNLIST_FN getColumnListFn;

  AQDB_CACHE *cache;

  uint32_t cacheHintMaxSize;
  uint32_t cacheHintMaxEntries;


  uint32_t refCount;
};



#endif






