/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_IOLAYER_CACHED_H
#define AQDB_IOLAYER_CACHED_H


#include "aqdatabase/backendsupport/iolayer.h"

#include <gwenhywfar/multicache.h>


int AQDB_IoLayerCached_Extend(AQDB_IOLAYER *ioLayer);

GWEN_MULTICACHE_TYPE *AQDB_IoLayerCached_CreateCacheType(const AQDB_IOLAYER *ioLayer);

int AQDB_IoLayerCached_LockCacheMutex(AQDB_IOLAYER *ioLayer);
int AQDB_IoLayerCached_UnlockCacheMutex(AQDB_IOLAYER *ioLayer);



#endif


