/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_IOLAYER_CACHED_P_H
#define AQDB_IOLAYER_CACHED_P_H

#include "aqdatabase/backendsupport/iocached/layer.h"

#include <gwenhywfar/mutex.h>



typedef struct AQDB_IOLAYER_CACHED AQDB_IOLAYER_CACHED;
struct AQDB_IOLAYER_CACHED {

  GWEN_MULTICACHE *multiCache;

  GWEN_MUTEX *cacheMutex;

  AQDB_IOLAYER_OPEN_FN openFn;
  AQDB_IOLAYER_CLOSE_FN closeFn;

  AQDB_IOLAYER_BEGINEDIT_FN beginEditFn;
  AQDB_IOLAYER_ENDEDIT_FN endEditFn;

  AQDB_IOLAYER_CREATETABLE_FN createTableFn;
  AQDB_IOLAYER_OPENTABLE_FN openTableFn;
  AQDB_IOLAYER_CLOSETABLE_FN closeTableFn;

  AQDB_IOLAYER_SETOBJECTPOS_FN setObjectPosFn;

  AQDB_IOLAYER_ADDOBJECT_FN addObjectFn;
  AQDB_IOLAYER_DELETEOBJECT_FN deleteObjectFn;
  AQDB_IOLAYER_WRITEOBJECT_FN writeObjectFn;
  AQDB_IOLAYER_READOBJECT_FN readObjectFn;

};



#endif

