/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_IOLAYER_CACHED_TABLE_H
#define AQDB_IOLAYER_CACHED_TABLE_H


#include "aqdatabase/backendsupport/iolayer.h"
#include "aqdatabase/backendsupport/table.h"

#include <gwenhywfar/multicache.h>


int AQDB_IoLayerCached_Table_Extend(AQDB_TABLE *dbt);
void AQDB_IoLayerCached_Table_Unextend(AQDB_TABLE *dbt);
int AQDB_IoLayerCached_Table_IsOfType(const AQDB_TABLE *dbt);


void AQDB_IoLayerCached_Table_PurgeCaches(AQDB_TABLE *dbt);

GWEN_MULTICACHE_TYPE *AQDB_IoLayerCached_Table_GetReaderCache(const AQDB_TABLE *dbt);
void AQDB_IoLayerCached_Table_SetReaderCache(AQDB_TABLE *dbt, GWEN_MULTICACHE_TYPE *mct);

GWEN_MULTICACHE_TYPE *AQDB_IoLayerCached_Table_GetWriterCache(const AQDB_TABLE *dbt);
void AQDB_IoLayerCached_Table_SetWriterCache(AQDB_TABLE *dbt, GWEN_MULTICACHE_TYPE *mct);


#endif


