/****************************************************************************
 * This file is part of the project AqFinance.
 * AqDataBase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQDB_IOLAYER_QUERY_QUERY_H
#define AQDB_IOLAYER_QUERY_QUERY_H


#include "aqdatabase/backendsupport/iolayer.h"

#include <aqdatabase/aqdb_db.h>




int AQDB_IoLayerQuery_QuerySubmit(AQDB_IOLAYER *ioLayer,
                                  uint32_t accessFlags,
                                  AQDB_TABLE *dbt,
                                  AQDB_ID refQueryId,
                                  const char *queryExpression,
                                  uint32_t queryFlags,
                                  AQDB_ID *pQueryId);

int AQDB_IoLayerQuery_QueryGetFirst(AQDB_IOLAYER *ioLayer,
                                    AQDB_ID queryId,
                                    AQDB_ID *pIdListPtr,
                                    int *pIdListLen);

int AQDB_IoLayerQuery_QueryGetNext(AQDB_IOLAYER *ioLayer,
                                   AQDB_ID queryId,
                                   AQDB_ID *pIdListPtr,
                                   int *pIdListLen);

int AQDB_IoLayerQuery_QueryClose(AQDB_IOLAYER *ioLayer,
                                 AQDB_ID queryId);




#endif

