/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_IOLAYER_QUERY_H
#define AQDB_IOLAYER_QUERY_H


#include "aqdatabase/backendsupport/iolayer.h"

#include <aqdatabase/aqdb_db_be.h>
#include <aqdatabase/backendsupport/aqdb_query_result.h>



int AQDB_IoLayerQuery_Extend(AQDB_IOLAYER *ioLayer);

AQDB_QUERY_RESULT_LIST *AQDB_IoLayerQuery_GetQueryResultList(const AQDB_IOLAYER *ioLayer);
void AQDB_IoLayerQuery_ClearQueryResultList(AQDB_IOLAYER *ioLayer);

uint64_t AQDB_IoLayerQuery_GetLastQueryId(const AQDB_IOLAYER *ioLayer);
void AQDB_IoLayerQuery_SetLastQueryId(AQDB_IOLAYER *ioLayer, uint64_t id);

int AQDB_IoLayerQuery_LockQueryMutex(AQDB_IOLAYER *ioLayer);
int AQDB_IoLayerQuery_UnlockQueryMutex(AQDB_IOLAYER *ioLayer);


GWEN_IDLIST64 *AQDB_IoLayerQuery_GetActiveIds(AQDB_IOLAYER *ioLayer, uint32_t accessFlags, AQDB_TABLE *dbt, uint32_t queryFlags);
int AQDB_IoLayerQuery_ReadObject(AQDB_IOLAYER *ioLayer,
                                 uint32_t aflags,
                                 AQDB_TABLE *dbt,
                                 AQDB_ID objectId,
                                 AQDB_OBJECT **pObject);


#endif

