/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_IOLAYER_QUERY_P_H
#define AQDB_IOLAYER_QUERY_P_H

#include "aqdatabase/backendsupport/ioquery/layer.h"

#include <gwenhywfar/mutex.h>


typedef struct AQDB_IOLAYER_QUERY AQDB_IOLAYER_QUERY;
struct AQDB_IOLAYER_QUERY {
  GWEN_MUTEX *mutexForQueries;

  uint64_t lastQueryId;
  AQDB_QUERY_RESULT_LIST *queryResultList;


  AQDB_IOLAYER_CREATE_FN createFn;
  AQDB_IOLAYER_OPEN_FN openFn;
  AQDB_IOLAYER_CLOSE_FN closeFn;

  AQDB_IOLAYER_QUERYSUBMIT_FN querySubmitFn;
  AQDB_IOLAYER_QUERYGETFIRST_FN queryGetFirstFn;
  AQDB_IOLAYER_QUERYGETNEXT_FN queryGetNextFn;
  AQDB_IOLAYER_QUERYCLOSE_FN queryCloseFn;

  AQDB_IOLAYER_GETACTIVEIDSFORTABLE_FN getActiveIdsForTableFn;

  AQDB_IOLAYER_READOBJECT_FN readObjectFn;

};



#endif

