/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_IOLAYER_TIMED_P_H
#define AQDB_IOLAYER_TIMED_P_H

#include "aqdatabase/backendsupport/iotimed/layer.h"


typedef struct timerArray timerArray;
struct timerArray {
  unsigned long long int numMeasurements;
  unsigned long long int sumMeasurements;
  unsigned long long int minMeasurement;
  unsigned long long int maxMeasurement;
};


typedef struct AQDB_IOLAYER_TIMED AQDB_IOLAYER_TIMED;
struct AQDB_IOLAYER_TIMED {

  AQDB_IOLAYER_CREATE_FN createFn;
  AQDB_IOLAYER_OPEN_FN openFn;
  AQDB_IOLAYER_CLOSE_FN closeFn;

  AQDB_IOLAYER_BEGINEDIT_FN beginEditFn;
  AQDB_IOLAYER_ENDEDIT_FN endEditFn;

  AQDB_IOLAYER_QUERYSUBMIT_FN querySubmitFn;
  AQDB_IOLAYER_QUERYGETFIRST_FN queryGetFirstFn;
  AQDB_IOLAYER_QUERYGETNEXT_FN queryGetNextFn;
  AQDB_IOLAYER_QUERYCLOSE_FN queryCloseFn;

  AQDB_IOLAYER_ADDOBJECT_FN addObjectFn;
  AQDB_IOLAYER_DELETEOBJECT_FN deleteObjectFn;
  AQDB_IOLAYER_WRITEOBJECT_FN writeObjectFn;
  AQDB_IOLAYER_READOBJECT_FN readObjectFn;

  timerArray *beginEditTimers;
  timerArray *endEditTimers;

  timerArray *querySubmitTimers;
  timerArray *queryGetFirstTimers;
  timerArray *queryGetNextTimers;
  timerArray *queryCloseTimers;

  timerArray *addObjectTimers;
  timerArray *deleteObjectTimers;
  timerArray *writeObjectTimers;
  timerArray *readObjectTimers;

};


#endif

