/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQDB_USER_SESSION_P_H
#define AQDB_USER_SESSION_P_H

#include "aqdatabase/user/aqdb_session.h"



#define AQDB_USER_SESSION_MAX_TABLES  128
#define AQDB_USER_SESSION_MAX_QUERIES 128

#define AQDB_USER_SESSION_MAX_GROUPS  16



struct AQDB_USER_SESSION {
  GWEN_INHERIT_ELEMENT(AQDB_USER_SESSION)

  AQDB_DB *database;

  char *sessionName;

  /* info read from DB */
  char *userName;
  AQDB_ID userId;
  AQDB_ID primaryGroupId;
  AQDB_ID secondaryGroupId;
  uint32_t userPermissions;

  AQDB_ID groupIds[AQDB_USER_SESSION_MAX_GROUPS];

  /* runtime data */
  AQDB_USER_TABLE *openTables[AQDB_USER_SESSION_MAX_TABLES];
  AQDB_ID openQueryIds[AQDB_USER_SESSION_MAX_QUERIES];

  int isInEditMode;
};



#endif

