/****************************************************************************
 * This file is part of the project AqDatabase.
 * AqDatabase (c) by 2007 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQDB_USERDB_P_H
#define AQDB_USERDB_P_H


#include <aqdatabase/aqdb.h>
#include <aqdatabase/aqdb_db.h>
#include <aqdatabase/aqdb_db_be.h>


#define AQDB_USERDB_TABLENAME_USERS     "+users"
#define AQDB_USERDB_TABLENAME_GROUPS    "+groups"

#define AQDB_USERDB_TABLENAME_USERACL   "+useracl"
#define AQDB_USERDB_TABLENAME_GROUPACL  "+groupacl"

#define AQDB_USERDB_TABLENAME_IDS       "+ids"


typedef struct AQDB_USERDB AQDB_USERDB;
struct AQDB_USERDB {
  AQDB_ID tableIdUsers;
  AQDB_ID tableIdGroups;

  AQDB_ID tableIdUserAcl;
  AQDB_ID tableIdGroupAcl;

  AQDB_ID tableIdIdDef;

  AQDB_DB_OPEN_FN openFn;
  AQDB_DB_CREATE_FN createFn;
  AQDB_DB_CLOSE_FN closeFn;

  AQDB_DB_CREATETABLE_FN createTableFn;
  AQDB_DB_GETTABLENAMELIST_FN getTableNameListFn;

  AQDB_DB_READOBJECT_FN readObjectFn;
  AQDB_DB_WRITEOBJECT_FN writeObjectFn;
  AQDB_DB_ADDOBJECT_FN addObjectFn;
  AQDB_DB_DELETEOBJECT_FN deleteObjectFn;

  AQDB_DB_QUERYSUBMIT_FN querySubmitFn;
  AQDB_DB_QUERYGETFIRST_FN queryGetFirstFn;
  AQDB_DB_QUERYGETNEXT_FN queryGetNextFn;
  AQDB_DB_QUERYCLOSE_FN queryCloseFn;

};


#endif

