/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif


#include "object_descr_p.h"
#include "dbdir_l.h"



GWEN_LIST_FUNCTIONS(AQDB_DBDIR_OBJDESCR, AQDB_DbDir_ObjectDescr)
GWEN_IDMAP_FUNCTIONS(AQDB_DBDIR_OBJDESCR, AQDB_DbDir_ObjectDescr)




AQDB_DBDIR_OBJDESCR *AQDB_DbDir_ObjectDescr_new()
{
  AQDB_DBDIR_OBJDESCR *od;

  GWEN_NEW_OBJECT(AQDB_DBDIR_OBJDESCR, od);
  GWEN_LIST_INIT(AQDB_DBDIR_OBJDESCR, od);

  return od;
}



void AQDB_DbDir_ObjectDescr_free(AQDB_DBDIR_OBJDESCR *od)
{
  if (od) {
    GWEN_LIST_FINI(AQDB_DBDIR_OBJDESCR, od);
    GWEN_FREE_OBJECT(od);
  }
}



AQDB_ID AQDB_DbDir_ObjectDescr_GetSessionLogId(const AQDB_DBDIR_OBJDESCR *od)
{
  assert(od);
  return od->sessionLogId;
}



void AQDB_DbDir_ObjectDescr_SetSessionLogId(AQDB_DBDIR_OBJDESCR *od, AQDB_ID id)
{
  assert(od);
  od->sessionLogId=id;
}



AQDB_ID AQDB_DbDir_ObjectDescr_GetObjectTableId(const AQDB_DBDIR_OBJDESCR *od)
{
  assert(od);
  return od->objectTableId;
}



void AQDB_DbDir_ObjectDescr_SetObjectTableId(AQDB_DBDIR_OBJDESCR *od, AQDB_ID id)
{
  assert(od);
  od->objectTableId=id;
}



AQDB_ID AQDB_DbDir_ObjectDescr_GetObjectId(const AQDB_DBDIR_OBJDESCR *od)
{
  assert(od);
  return od->objectId;
}



void AQDB_DbDir_ObjectDescr_SetObjectId(AQDB_DBDIR_OBJDESCR *od, AQDB_ID id)
{
  assert(od);
  od->objectId=id;
}



int AQDB_DbDir_ObjectDescr_GetEntryType(const AQDB_DBDIR_OBJDESCR *od)
{
  assert(od);
  return od->entryType;
}



void AQDB_DbDir_ObjectDescr_SetEntryType(AQDB_DBDIR_OBJDESCR *od, int i)
{
  assert(od);
  od->entryType=i;
}









