/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2010 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQDB_DBDIR_OBJECT_DESCR_L_H
#define AQDB_DBDIR_OBJECT_DESCR_L_H

#include <gwenhywfar/list1.h>
#include <gwenhywfar/idmap.h>

#include <aqdatabase/aqdb_db_be.h>


typedef struct AQDB_DBDIR_OBJDESCR AQDB_DBDIR_OBJDESCR;
GWEN_LIST_FUNCTION_DEFS(AQDB_DBDIR_OBJDESCR, AQDB_DbDir_ObjectDescr)
GWEN_IDMAP_FUNCTION_DEFS(AQDB_DBDIR_OBJDESCR, AQDB_DbDir_ObjectDescr)


AQDB_DBDIR_OBJDESCR *AQDB_DbDir_ObjectDescr_new();
void AQDB_DbDir_ObjectDescr_free(AQDB_DBDIR_OBJDESCR *od);

AQDB_ID AQDB_DbDir_ObjectDescr_GetSessionLogId(const AQDB_DBDIR_OBJDESCR *od);
void AQDB_DbDir_ObjectDescr_SetSessionLogId(AQDB_DBDIR_OBJDESCR *od, AQDB_ID id);

AQDB_ID AQDB_DbDir_ObjectDescr_GetObjectTableId(const AQDB_DBDIR_OBJDESCR *od);
void AQDB_DbDir_ObjectDescr_SetObjectTableId(AQDB_DBDIR_OBJDESCR *od, AQDB_ID id);

AQDB_ID AQDB_DbDir_ObjectDescr_GetObjectId(const AQDB_DBDIR_OBJDESCR *od);
void AQDB_DbDir_ObjectDescr_SetObjectId(AQDB_DBDIR_OBJDESCR *od, AQDB_ID id);

int AQDB_DbDir_ObjectDescr_GetEntryType(const AQDB_DBDIR_OBJDESCR *od);
void AQDB_DbDir_ObjectDescr_SetEntryType(AQDB_DBDIR_OBJDESCR *od, int i);


#endif

