/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqFileStore (c) by 2018 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQFS_FILE_HEADER_P_H
#define AQFS_FILE_HEADER_P_H

#include "aqfs_file_header.h"



#define AQFS_FILE_HEADER_OFFS_MAGIC     0    /* 4 bytes file magic "AQFS" */
#define AQFS_FILE_HEADER_OFFS_VERSION   4    /* 4 bytes (uint32_t) */
#define AQFS_FILE_HEADER_OFFS_FILE_SIZE 8    /* 8 bytes (uint64_t) */



struct AQFS_FILE_HEADER {
  uint32_t version;
  uint64_t fileSize;

  uint32_t refCount;
};



#endif
