/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqFileStore (c) by 2018 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQFS_ITEM_HEADER_P_H
#define AQFS_ITEM_HEADER_P_H


#include "aqfs_item_header.h"



#define AQFS_ITEM_HEADER_OFFS_SIZE_ALLOCATED 0    /* 8 bytes (uint64_t) */
#define AQFS_ITEM_HEADER_OFFS_SIZE_USED      8    /* 8 bytes (uint64_t) */
#define AQFS_ITEM_HEADER_OFFS_DATA_TYPE      16   /* 4 bytes (uint32_t) */



struct AQFS_ITEM_HEADER {
  uint64_t sizeAllocated;
  uint64_t sizeUsed;
  uint32_t dataType;


  uint64_t offsetHeaderStart;  /* not stored in file */
  uint64_t offsetDataStart;    /* not stored in file */
  uint32_t refCount;
};



#endif
