/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqFileStore (c) by 2018 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQFS_TABLE_P_H
#define AQFS_TABLE_P_H


#include "aqfs_table.h"



#define AQFS_TABLE_OFFS_MAX_ENTRIES      0          /* 8 bytes (uint64_t) */
#define AQFS_TABLE_OFFS_FREE_ENTRIES     8          /* 8 bytes (uint64_t) */
#define AQFS_TABLE_OFFS_HIGHEST_ENTRY    16         /* 8 bytes (uint64_t) */
#define AQFS_TABLE_OFFS_NEXT_TABLE       24         /* 8 bytes (uint64_t) */
#define AQFS_TABLE_OFFS_ENTRIES          32         /* n x 8 bytes (uint64_t) */



struct AQFS_TABLE {
  GWEN_LIST_ELEMENT(AQFS_TABLE)

  uint64_t maxEntries;
  uint64_t freeEntries;
  uint64_t highestEntry;
  uint64_t offsetNextTable;
  uint64_t *ptrEntries;

  uint64_t offsetTableHeaderStart;  /* not stored in file */
  uint32_t refCount;                /* not stored in file */
  uint32_t runtimeFlags;            /* not stored in file */
};



#endif
