/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFileStore (c) by 2018 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQFS_TABLE_PTRLIST_H
#define AQFS_TABLE_PTRLIST_H

#include <aqdatabase/aqdb_db_be.h>

#include <gwenhywfar/simpleptrlist.h>
#include <gwenhywfar/testframework.h>


typedef GWEN_SIMPLEPTRLIST AQFS_TABLE_PTRLIST;

#include <aqfilestorage/aqfs_table.h>




AQFS_TABLE_PTRLIST *AQFS_Table_PtrList_new(int tableMaxEntries);
void AQFS_Table_PtrList_free(AQFS_TABLE_PTRLIST *tl);

void AQFS_Table_PtrList_Clear(AQFS_TABLE_PTRLIST *tl);

AQFS_TABLE_PTRLIST *AQFS_Table_PtrList_LazyCopy(AQFS_TABLE_PTRLIST *oldList);


AQFS_TABLE *AQFS_Table_PtrList_GetTableAt(const AQFS_TABLE_PTRLIST *tl, uint64_t idx);
int AQFS_Table_PtrList_SetTableAt(AQFS_TABLE_PTRLIST *tl, uint64_t idx, AQFS_TABLE *t);
int64_t AQFS_Table_PtrList_AddTable(AQFS_TABLE_PTRLIST *tl, AQFS_TABLE *t);

int64_t AQFS_Table_PtrList_GetLastTablePos(const AQFS_TABLE_PTRLIST *tl);
uint64_t AQFS_Table_PtrList_GetUsedTables(const AQFS_TABLE_PTRLIST *tl);

int64_t AQFS_Table_PtrList_GetEntryAt(const AQFS_TABLE_PTRLIST *tl, uint64_t idx);
int AQFS_Table_PtrList_SetEntryAt(AQFS_TABLE_PTRLIST *tl, uint64_t idx, uint64_t entry);
int64_t AQFS_Table_PtrList_AddEntry(AQFS_TABLE_PTRLIST *tl, uint64_t entry);


int AQFS_Table_PtrList_GetTableMaxEntries(const AQFS_TABLE_PTRLIST *tl);


int AQFS_Table_PtrList_AddTests(GWEN_TEST_MODULE *mod);


#endif
