/****************************************************************************
 * This file is part of the project AqFinance.
 * AqDataBase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQDB_DBFILE_H
#define AQDB_DBFILE_H


#include <aqdatabase/aqdb_db.h>


/** @file dbfile.h
 *
 * This plugin uses a single AQFS_FILE file to store the data.
 *
 * The first object after the AQFS_FILE_HEADER is a table (@ref AQFS_TABLE) which contains offset entries to the database data.
 * The following entries of that table are used so far:
 * - index 0: database header item (see @ref AQDB_DBFILE_HEADER)
 * - index 1: types table (see @ref AQDB_DBFILE_TABLE)
 *
 */




AQDB_DB *AQDB_DbFile_new(const char *urlString);


#endif
