/****************************************************************************
 * This file is part of the project AqFinance.
 * AqDataBase (c) by 2015 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQDB_DBFILE_HEADER_L_H
#define AQDB_DBFILE_HEADER_L_H

#include <aqdatabase/aqdb_db_be.h>


#define AQDB_DBFILE_VERSION 0x010000

#define AQDB_DBFILE_HEADER_SIZE 256



typedef struct AQDB_DBFILE_HEADER AQDB_DBFILE_HEADER;



AQDB_DBFILE_HEADER *AQDB_DbFile_Header_new();
void AQDB_DbFile_Header_free(AQDB_DBFILE_HEADER *dbh);


int AQDB_DbFile_Header_ReadFromBuffer(AQDB_DBFILE_HEADER *dbh, const uint8_t *buffer, uint64_t len);
AQDB_DBFILE_HEADER *AQDB_DbFile_Header_fromBuffer(const uint8_t *buffer, uint64_t len);
int64_t AQDB_DbFile_Header_toBuffer(const AQDB_DBFILE_HEADER *dbh, uint8_t *buffer, uint64_t len);


uint64_t AQDB_DbFile_Header_GetVersion(const AQDB_DBFILE_HEADER *dbh);
void AQDB_DbFile_Header_SetVersion(AQDB_DBFILE_HEADER *dbh, uint64_t i);

uint64_t AQDB_DbFile_Header_GetLastSessionId(const AQDB_DBFILE_HEADER *dbh);
void AQDB_DbFile_Header_SetLastSessionId(AQDB_DBFILE_HEADER *dbh, uint64_t i);





#endif
