/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_IOLAYER_LOGGED_H
#define AQDB_IOLAYER_LOGGED_H


#include "aqdatabase/backendsupport/iolayer.h"
#include "aqdatabase/backendsupport/table.h"

#include "file/changelog.h"


#define AQDB_DBFILE_SESSION_FLAGS_ROLLBACK       0x80000000



int AQDB_IoLayerLogged_Extend(AQDB_IOLAYER *ioLayer);



AQDB_ID AQDB_IoLayerLogged_GetTableIdSessionDescr(const AQDB_IOLAYER *ioLayer);
void AQDB_IoLayerLogged_SetTableIdSessionDescr(AQDB_IOLAYER *ioLayer, AQDB_ID id);

AQDB_ID AQDB_IoLayerLogged_GetTableIdChangeLog(const AQDB_IOLAYER *ioLayer);
void AQDB_IoLayerLogged_SetTableIdChangeLog(AQDB_IOLAYER *ioLayer, AQDB_ID id);

AQDB_SESSION_DESCR *AQDB_IoLayerLogged_GetCurrentSession(const AQDB_IOLAYER *ioLayer);
void AQDB_IoLayerLogged_SetCurrentSession(AQDB_IOLAYER *ioLayer, AQDB_SESSION_DESCR *sdescr);



#endif


