/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_IOLAYER_LOGGED_P_H
#define AQDB_IOLAYER_LOGGED_P_H

#include "file/iologged/layer.h"


typedef struct AQDB_IOLAYER_LOGGED AQDB_IOLAYER_LOGGED;
struct AQDB_IOLAYER_LOGGED {

  /** id of the type table containing session descriptions. */
  AQDB_ID tableIdSessionDescr;

  /** id of the type table containing changelog entries for the rollback log */
  AQDB_ID tableIdChangeLog;

  AQDB_SESSION_DESCR *currentSession;

  uint32_t editFlags;


  AQDB_IOLAYER_CREATE_FN createFn;
  AQDB_IOLAYER_OPEN_FN openFn;
  AQDB_IOLAYER_CLOSE_FN closeFn;

  AQDB_IOLAYER_BEGINEDIT_FN beginEditFn;
  AQDB_IOLAYER_ENDEDIT_FN endEditFn;

  AQDB_IOLAYER_CREATETABLE_FN createTableFn;
  AQDB_IOLAYER_OPENTABLE_FN openTableFn;
  AQDB_IOLAYER_CLOSETABLE_FN closeTableFn;

  AQDB_IOLAYER_QUERYSUBMIT_FN querySubmitFn;
  AQDB_IOLAYER_QUERYGETFIRST_FN queryGetFirstFn;
  AQDB_IOLAYER_QUERYGETNEXT_FN queryGetNextFn;
  AQDB_IOLAYER_QUERYCLOSE_FN queryCloseFn;

  AQDB_IOLAYER_GETACTIVEIDSFORTABLE_FN getActiveIdsForTableFn;

  AQDB_IOLAYER_GETOBJECTPOS_FN getObjectPosFn;
  AQDB_IOLAYER_SETOBJECTPOS_FN setObjectPosFn;

  AQDB_IOLAYER_ADDOBJECT_FN addObjectFn;
  AQDB_IOLAYER_DELETEOBJECT_FN deleteObjectFn;
  AQDB_IOLAYER_WRITEOBJECT_FN writeObjectFn;
  AQDB_IOLAYER_READOBJECT_FN readObjectFn;

  AQDB_IOLAYER_GETROLLBACKSESSIONS_FN getRollbackSessionsFn;
  AQDB_IOLAYER_UNDOSESSION_FN undoSessionFn;

};



#endif

