/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_IOLAYER_LOWLEVEL_IO_OBJECT_H
#define AQDB_IOLAYER_LOWLEVEL_IO_OBJECT_H


#include "file/iolowlevel/layer.h"



int AQDB_IoLayerLowlevel_AddObject(AQDB_IOLAYER *ioLayer, AQDB_TABLE *dbt, AQDB_OBJECT *object);
int AQDB_IoLayerLowlevel_DeleteObject(AQDB_IOLAYER *ioLayer, AQDB_TABLE *dbt, AQDB_ID objectId);
int AQDB_IoLayerLowlevel_WriteObject(AQDB_IOLAYER *ioLayer, AQDB_TABLE *dbt, const AQDB_OBJECT *object);
int AQDB_IoLayerLowlevel_ReadObject(AQDB_IOLAYER *ioLayer, uint32_t aflags, AQDB_TABLE *dbt,
                                      AQDB_ID objectId, AQDB_OBJECT **pObject);


int64_t AQDB_IoLayerLowlevel_AppendObject(AQDB_IOLAYER *ioLayer, AQFS_TABLE_LIST *ftl, AQDB_OBJECT *o);
int AQDB_IoLayerLowlevel_ReadObjectAt(AQDB_IOLAYER *ioLayer, AQDB_OBJECT *object, uint64_t offset);

#endif

