/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDataBase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AQDB_IOLAYER_LOWLEVEL_IO_TABLE_H
#define AQDB_IOLAYER_LOWLEVEL_IO_TABLE_H


#include "file/iolowlevel/layer.h"
#include "file/iolowlevel/table.h"


AQDB_TABLE *AQDB_IoLayerLowlevel_CreateTable(AQDB_IOLAYER *ioLayer,
                                             const char *name,
                                             uint32_t flags,
                                             const AQDB_COLUMN_LIST *columns);
AQDB_TABLE *AQDB_IoLayerLowlevel_OpenTable(AQDB_IOLAYER *ioLayer,
                                           uint32_t aflags,
                                           const char *tname,
                                           uint32_t flags,
                                           AQDB_ID *pTableId);
int AQDB_IoLayerLowlevel_CloseTable(AQDB_IOLAYER *ioLayer, AQDB_TABLE *dbt, uint32_t flags);



int AQDB_IoLayerLowlevel_ReadTableAt(AQDB_IOLAYER *ioLayer, AQDB_TABLE *dbt, uint64_t offset);


int64_t AQDB_IoLayerLowlevel_GetObjectPos(AQDB_IOLAYER *ioLayer,
                                          const AQDB_TABLE *dbt,
                                          uint64_t index,
                                          int asWriter);

int AQDB_IoLayerLowlevel_SetObjectPos(AQDB_IOLAYER *ioLayer,
                                      AQDB_TABLE *dbt,
                                      uint64_t index,
                                      uint64_t objectPos);


int AQDB_IoLayerLowlevel_BeginEditTable(AQDB_IOLAYER *ioLayer, AQDB_TABLE *dbt);
int AQDB_IoLayerLowlevel_EndEditTable(AQDB_IOLAYER *ioLayer, AQDB_TABLE *dbt, int abandon);


#endif

