/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_IOLAYER_LOWLEVEL_H
#define AQDB_IOLAYER_LOWLEVEL_H


#include "aqdatabase/backendsupport/iolayer.h"

#include "file/header_l.h"
#include "file/iolowlevel/table.h"

#include <aqdatabase/aqdb_db_be.h>
#include <aqdatabase/backendsupport/aqdb_query_result.h>

#include <aqfilestorage/aqfs_file.h>
#include <aqfilestorage/aqfs_table.h>

#include <gwenhywfar/fslock.h>


#define AQDB_DBFILE_TYPETABLE_MAXENTRIES   128

#define AQDB_DBFILE_DBDATA_INDEX_HEADER 0
#define AQDB_DBFILE_DBDATA_INDEX_TYPES  1


#define AQDB_DBFILE_IDLIST_ENTRIES 256



AQDB_IOLAYER *AQDB_IoLayerLowlevel_new(AQDB_DB *database, const GWEN_URL *url);

const char *AQDB_IoLayerLowlevel_GetDataFileName(const AQDB_IOLAYER *ioLayer);

AQFS_FILE *AQDB_IoLayerLowlevel_GetFile(const AQDB_IOLAYER *ioLayer);
void AQDB_IoLayerLowlevel_SetFile(AQDB_IOLAYER *ioLayer, AQFS_FILE *f);

GWEN_FSLOCK *AQDB_IoLayerLowlevel_GetFileLock(const AQDB_IOLAYER *ioLayer);
void AQDB_IoLayerLowlevel_SetFileLock(AQDB_IOLAYER *ioLayer, GWEN_FSLOCK *lck);


AQFS_TABLE_LIST *AQDB_IoLayerLowlevel_GetTableListDatabase(const AQDB_IOLAYER *ioLayer);
void AQDB_IoLayerLowlevel_SetTableListDatabase(AQDB_IOLAYER *ioLayer, AQFS_TABLE_LIST *ftl);

AQFS_TABLE_LIST *AQDB_IoLayerLowlevel_GetTableListTypes(const AQDB_IOLAYER *ioLayer);
void AQDB_IoLayerLowlevel_SetTableListTypes(AQDB_IOLAYER *ioLayer, AQFS_TABLE_LIST *ftl);

AQDB_DBFILE_HEADER *AQDB_IoLayerLowlevel_GetHeader(const AQDB_IOLAYER *ioLayer);
void AQDB_IoLayerLowlevel_SetHeader(AQDB_IOLAYER *ioLayer, AQDB_DBFILE_HEADER *dbh);


#endif

