/****************************************************************************
 * This file is part of the project AqDataBase.
 * AqDatabase (c) by 2020 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_IOLAYER_LOWLEVEL_TABLE_P_H
#define AQDB_IOLAYER_LOWLEVEL_TABLE_P_H


#include "file/iolowlevel/table.h"

#include <aqdatabase/aqdb_db_be.h>
#include <aqdatabase/aqdb_column.h>

#include <aqfilestorage/aqfs_table.h>

#include <gwenhywfar/list1.h>
#include <gwenhywfar/inherit.h>
#include <gwenhywfar/multicache.h>



#define AQDB_DBFILE_TABLE_OFFS_COLUMN_TABLE 0   /* 8 bytes (uint64_t) */
#define AQDB_DBFILE_TABLE_OFFS_OBJECT_TABLE 8   /* 8 bytes (uint64_t) */
#define AQDB_DBFILE_TABLE_OFFS_NAME         16  /* 64 bytes */
#define   AQDB_DBFILE_TABLE_SIZE_NAME       64



typedef struct AQDB_IOLAYER_LOWLEVEL_TABLE AQDB_IOLAYER_LOWLEVEL_TABLE;
struct AQDB_IOLAYER_LOWLEVEL_TABLE {
  /* data in file */
  uint64_t offsetColumnTable;
  uint64_t offsetObjectTable;

  /* runtime representation of some info from file */
  AQFS_TABLE_LIST *tableListColumns;

  AQFS_TABLE_PTRLIST *readersTablePtrListObjects;
  AQFS_TABLE_PTRLIST *writersTablePtrListObjects;
};



#endif


