/****************************************************************************
 * This file is part of the project AqDatabase.
 * AqDatabase (c) by 2019 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef AQDB_TOOL_UTILS_H
#define AQDB_TOOL_UTILS_H


#include <aqdatabase/aqdb.h>
#include <aqdatabase/aqdb_db.h>



/**
 * Create a database column list from a given string thus defining a database type.
 *
 * Example string: "field1:int:8, field2:string:256, field3:date".
 */
AQDB_COLUMN_LIST *DbTool_ColumnList_fromString(const char *sourceString);

void DbTool_DumpColumnList(const AQDB_COLUMN_LIST *columnList);

void DbTool_DumpColumn(const AQDB_COLUMN *column);


/**
 * Fill object fields with data given in a string.
 *
 * Example string: "field1=data1, field2=data2, field3=data3".
 */
int DbTool_ReadObjectFromString(const char *sourceString,
                                const AQDB_COLUMN_LIST *columnList,
                                AQDB_OBJECT *object);


/**
 * "field1=xyz, field2=abc"
 */


#endif

